;
;      SCRIPT: BRANCH.SC
;      AUTHOR: Matthew Hopkins
; DESCRIPTION: This script contains PAL code to help explain the concept of
;              branching dynarrays.  This very basic script, produces a popup
;              demonstrating the power and speed of branched dynamic arrays.

PROC CreateArrays()
  DYNARRAY Grocery.y[]
  Grocery.y["Produce.y"] = "Produce"
  Grocery.y["Canned.y"]  = "Canned"

  DYNARRAY Produce.y[]
  Produce.y["Grocery.y"]    = "<previous>"
  Produce.y["Fruit.y"]      = "Fruit"
  Produce.y["Vegetables.y"] = "Vegetables"

  DYNARRAY Fruit.y[]
  Fruit.y["Produce.y"] = "<previous>"
  Fruit.y["Apples.y"]  = "Apples"
  Fruit.y["Lemons.y"]  = "Lemons"
  Fruit.y["Oranges.y"] = "Oranges"

  DYNARRAY Vegetables.y[]
  Vegetables.y["Produce.y"] = "<previous>"
  Vegetables.y["Carrots.y"] = "Carrots"
  Vegetables.y["Celery.y"]  = "Celery"
  Vegetables.y["Lettuce.y"] = "Lettuce"

  DYNARRAY Canned.y[]
  Canned.y["Grocery.y"]     = "<previous>"
  Canned.y["Soup.y"]        = "Soup"
  Canned.y["CannedMeat.y"]  = "Canned Meat"

  DYNARRAY Soup.y[]
  Soup.y["Canned.y"]            = "<previous>"
  Soup.y["Tomato.y"]            = "Tomato"
  Soup.y["CreamofMushroom.y"]   = "Cream of Mushroom"
  Soup.y["ChickenNoodle.y"]     = "Chicken Noodle"

  DYNARRAY CannedMeat.y[]
  CannedMeat.y["Canned.y"] = "<previous>"
  CannedMeat.y["Tuna.y"]   = "Tuna"
  CannedMeat.y["Salmon.y"] = "Salmon"
  CannedMeat.y["SPAM.y"]   = "SPAM"
ENDPROC

PROC GenerateDisplayArray()
  executestring.a = "DYNARRAY DisplayArray.y[] "+
                    "FOREACH element.a IN "+CurrentArray.a+" "+
                    "  DisplayArray.y[element.a] = "+CurrentArray.a+"[element.a] "+
                    "ENDFOREACH"
  IF (LEN(executestring.a)<=255) THEN
    EXECUTE executestring.a
  ELSE
    FILEWRITE "$BRANCH$.SC" FROM executestring.a
    PLAY "$BRANCH$"
  ENDIF
ENDPROC

PROC Dialog()
  SHOWDIALOG "Groceries"
    PROC "DialogControl"
    TRIGGER "SELECT"
    @4,23 HEIGHT 13 WIDTH 30

     @ 1,1 ?? SUBSTR(CurrentArray.a,1,LEN(CurrentArray.a)-2)

     PICKDYNARRAY @2,1 HEIGHT 6 WIDTH 25
        COLUMNS 1
        DisplayArray.y
        TAG "DisplayArray"
        TO DisplayArray.a

     PUSHBUTTON @9,6 WIDTH 6
        "Ok"
        OK
        VALUE "OK"
        TAG "OKButton"
        TO ButtonValue.a

     PUSHBUTTON @9,12 WIDTH 10
        "Cancel"
        CANCEL
        VALUE "Cancel"
        TAG "CancelButton"
        TO ButtonValue.a
  ENDDIALOG
ENDPROC

PROC DialogControl(EventType,TagValue,EventValue,ElementValue)
  IF (EventType = "SELECT") THEN
    IF (TagValue = "DisplayArray") THEN
      DisplayArray.a   = CONTROLVALUE(TagValue)
      IF (DYNARRAYSIZE(VARVAL(DisplayArray.a))<>0) THEN
        CurrentArray.a = DisplayArray.a
        GenerateDisplayArray()
        REPAINTDIALOG
        REFRESHCONTROL TagValue
      ELSE
        BEEP
      ENDIF
    ENDIF
  ENDIF
ENDPROC

CurrentArray.a = "Grocery.y"
CreateArrays()
GenerateDisplayArray()
Dialog()
